#ifndef LEVELS_H
#define LEVELS_H

#include "stuff.h"
#include "stdint.h"

class Levels
{
public:
	Levels () {}
	
	void load ();
	void save ();

	void selectLevel (int level) {activeLevel = level - 1;}
	void incrementLevel () {activeLevel = (activeLevel + 1) % MAX_LEVELS;}
	
	int getWinNum ();
	int getColour (int x, int y);
	bool getSink (int x, int y);
	int getDudeFacing (int x, int y);
	int getDudeColour (int x, int y);
	int getDudePresent (int x, int y);
	
	void setWinNum (int winNum);
	void setColour (int x, int y, int colour);
	void setSink (int x, int y, bool sink);
	void setDudeFacing (int x, int y, int dudeFacing);
	void setDudeColour (int x, int y, int dudeColour);
	void setDudePresent (int x, int y, bool dudePresent);

protected:

	void setThingy (int x, int y, uint8_t goods, uint8_t mask);

	int activeLevel;

	uint8_t data [MAX_LEVELS][GRID_SIZE][GRID_SIZE];
	uint8_t head_data [MAX_LEVELS];

};

#endif