
#include "opengl_includes.h"
#include "stuff.h"
#include "world.h"

World* gWorld;

int gMouseX = -1;
int gMouseY = -1;

int gNextTime;

void display (void)
{
	glClear (GL_COLOR_BUFFER_BIT);
	gWorld->draw ();
	int GridMouseX = (gMouseX / CELL_SIZE) + 1;
	int GridMouseY = GRID_SIZE - (gMouseY / CELL_SIZE);
	glColor3f (0.6, 0.7, 0.2);
	
	glRectf (GridMouseX - 0.0, GridMouseY - 0.0, GridMouseX - 0.2, GridMouseY - 1.0);
	glRectf (GridMouseX - 0.8, GridMouseY - 0.0, GridMouseX - 1.0, GridMouseY - 1.0);
	glRectf (GridMouseX - 0.0, GridMouseY - 0.0, GridMouseX - 1.0, GridMouseY - 0.2);
	glRectf (GridMouseX - 0.0, GridMouseY - 0.8, GridMouseX - 1.0, GridMouseY - 1.0);

	glutSwapBuffers ();
}

void passiveMotion (int x, int y)
{
	gMouseX = x;
	gMouseY = y;
}

void mouse (int button, int state, int x, int y)
{
	if (state == GLUT_DOWN) {
		int GridMouseX = (x / CELL_SIZE) + 1;
		int GridMouseY = GRID_SIZE - (y / CELL_SIZE);
		gWorld->clicked (GridMouseX, GridMouseY);
	}
}

void idle ()
{
	int time = glutGet (GLUT_ELAPSED_TIME);
	if (time > gNextTime) {
		gNextTime = time + MS_PER_FRAME;
		gWorld->step ();
		glutPostRedisplay ();
	}
}

int main(int argc, char *argv[])
{
	glutInit (&argc, argv);
#ifdef mac
	chdir ("../../..");
#endif
	glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE);
	glutInitWindowSize (GRID_SIZE * CELL_SIZE, (GRID_SIZE + 1) * CELL_SIZE);
	glutInitWindowPosition (100, 100);
	glutCreateWindow ("Sophia");
	glutSetCursor (GLUT_CURSOR_NONE);
	
	glutDisplayFunc (display);
	glutPassiveMotionFunc (passiveMotion);
	glutMouseFunc (mouse);
	glutIdleFunc (idle);
	
	glClearColor (0.0, 0.0, 0.0, 0.0);
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();
	glOrtho (0.0, GRID_SIZE, -1.0, GRID_SIZE, -1.0, 1.0);
	
	gNextTime = glutGet (GLUT_ELAPSED_TIME);
	
	gWorld = new World ();
	
	glutMainLoop ();
	
	delete gWorld;
}
 

