#ifndef WORLD_H
#define WORLD_H

#include <set>
#include <vector>
#include "stuff.h"

class Dude
{
public:
	Dude (int in_colour, int in_facing, int in_xLoc, int in_yLoc);

	void draw ();
	void step ();
	
	bool ready () {return position_step == 0;}
	
	int disallowedColour ();
	void getPosition (int& out_x, int& out_y) {out_x = xLoc; out_y = yLoc;}
	void getShifts (int& x_shift_front, int& y_shift_front, int& x_shift_floor, int& y_shift_floor, bool& wasMoving);
	
	void doThis (int act);
	
protected:
	int colour, action, facing;
	
	int xLoc, yLoc;
	
	int position_step, animation_step;

	void updateLocation ();
};

typedef std::set<Dude*> dude_set_t;
typedef std::vector<Dude*> dude_vector_t;

class World
{
public:
	World ();
	
	void draw ();
	void step ();
	
	void clicked (int x, int y);
	
protected:
	void flip (int x, int y);
	void flipWithGrey (int x, int y);

	void clearDudes ();
	void initMode ();

	void drawToolbar ();
	void drawClicks ();
	
	Dude* findDude (int x, int y);

	int grid [GRID_SIZE + 2][GRID_SIZE + 2];
	bool sinks [GRID_SIZE + 2][GRID_SIZE + 2];
	dude_set_t dudes;
	dude_vector_t toolDudes;
	
	int mode;
	int forseen_mode;
	int activeTool;
	int clicks;
	int delay;
	int sunkDudes;
	int totalDudes;
};

#endif